import java.awt.*;
import java.awt.event.*;

//codierter text darf ausser grossbuchstaben nur
//leerzeichen,zeilenumbrueche,etc. enthalten ,
//jedoch keine anderen sonderzeichen (d.h. max 26 zeichen)

//codierter text wird auf deutsche sprache hin analysiert

//codierter text muss hinreichend lang sein , da fuer die Decodierung statistische
//Methoden angewandt werden

//automatische Decodierung funktioniert desweiteren nur bei verhaeltnismaessig
//kleinen Schluesseln (d.h. Schluessellaenge << Textlaenge)







//##########################################################################
class	MessageBox extends Dialog implements ActionListener
{
	boolean	result;
	
	public MessageBox(Frame owner , String title , String msg)
	{
		super(owner , title , true);
		setBackground(Color.lightGray);
		setLayout(new BorderLayout());
		setSize(400,200);
		TextArea	tarea = new TextArea(msg , 50 , 2 , TextArea.SCROLLBARS_VERTICAL_ONLY);
		tarea.setEditable(false);
		add("Center" , tarea);
		Button	button = new Button("Ok");
		button.addActionListener(this);
		add("South" , button);
		Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
		setLocation( (d.width-getSize().width)/2 , (d.height-getSize().height)/2);
		setVisible(true);
	}
	
	public void actionPerformed(ActionEvent e)
	{
		result = e.getActionCommand().equals("Ok");
		setVisible(false);
		dispose();
	}
	
	public boolean getResult()
	{
		return result;
	}
}





//##########################################################################
class aufgabe_4_2 extends Frame implements ActionListener
{
	
	TextArea	ftext = new TextArea("" , 50 , 50 , TextArea.SCROLLBARS_VERTICAL_ONLY);
	TextField	fname = new TextField("" , 30);
	TextField	keytext = new TextField("" , 15);
	TextField	lentext = new TextField("" , 5);
	Button	loadfile = new Button("Load File");
	Button	friedmann = new Button("Friedmann");
	Button	kasiski = new Button("Kasiski");
	Button	getkey = new Button("Schlssel bestimmen");
	Button	decode = new Button("Entschlsseln");
	Button	exit = new Button("Exit");

	Code_Vigenere	vigenere = new Code_Vigenere();


	//##########################################################################
	aufgabe_4_2()
	{
		setFont(new Font("Courier" , Font.BOLD , 12));
		
		loadfile.setActionCommand("Load File");
		friedmann.setActionCommand("Friedmann");
		kasiski.setActionCommand("Kasiski");
		getkey.setActionCommand("GetKey");
		decode.setActionCommand("Decode");
		exit.setActionCommand("Exit");
		loadfile.addActionListener(this);
		friedmann.addActionListener(this);
		kasiski.addActionListener(this);
		getkey.addActionListener(this);
		decode.addActionListener(this);
		exit.addActionListener(this);
		
		Panel	panel = new Panel();
		panel.setLayout(new GridLayout(21,2));
		panel.add(loadfile);
		panel.add(fname);
		panel.add(new Label(""));
		panel.add(new Label(""));
		panel.add(new Label("Schlssellnge bestimmen:"));
		panel.add(new Label(""));
		panel.add(friedmann);
		panel.add(kasiski);
		panel.add(new Label("Schlssellnge :"));
		panel.add(lentext);
		panel.add(new Label(""));
		panel.add(new Label(""));
		panel.add(getkey);
		panel.add(keytext);
		panel.add(new Label(""));
		panel.add(new Label(""));
		panel.add(decode);
		panel.add(new Label(""));
		panel.add(new Label(""));
		panel.add(new Label(""));
		panel.add(exit);
		panel.add(new Label(""));
		
		//zu faul fuer GridBagLayout
		for (int i=0; i<19; i++)
			panel.add(new Label(""));
		
		setLayout(new GridLayout(1,2));
		add(panel);
		add(ftext);


		Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
		setSize(800,600);
		setLocation( (d.width-getSize().width)/2 , (d.height-getSize().height)/2);
		setTitle("Datensicherheit Uebung 04");
		setResizable(false);
		setVisible(true);

		fname.setText("vigenere.txt");
		String	s = vigenere.ReadFile(fname.getText());
		ftext.setText(s);

		addWindowListener(new WindowAdapter()
		{
			public void windowClosing(WindowEvent e)
			{
				dispose();
				System.exit(0);
			}
		});

	}//aufgabe_4_2()




	//##########################################################################
	public void actionPerformed(ActionEvent e)
	{
		String cmd = e.getActionCommand();

		if (cmd == "Load File")
		{
			String	s = vigenere.ReadFile(fname.getText());
			ftext.setText(s);
			repaint();
		}

		if (cmd == "Exit")
		{
			dispose();
			System.exit(0);
		}
				
		if (cmd == "Friedmann")
		{
			String	s = ftext.getText();
			int	len = vigenere.GetKeyLength_Friedmann(s);
//			String	s2 = "Geschtzte Schlssellnge  :  "+Long.toString(len);
//			MessageBox	msg = new MessageBox(this , "Friedmann" , s2);
			lentext.setText(Integer.toString(len));
		}
				
		if (cmd == "Kasiski")
		{
			String	s = ftext.getText();
			int len = vigenere.GetKeyLength_Kasiski(s);
			lentext.setText(Integer.toString(len));
//			int	len = GetKeyLength_Kasiski(s);
//			String	s2 = "Geschtzte Schlssellnge  :  "+Integer.toString(len);
//			MessageBox	msg = new MessageBox(this , "Kasiski" , s2);
		}
		
		if (cmd == "GetKey")
		{
			try
			{
				int keylen = Integer.parseInt(lentext.getText());
				if (keylen <= 0)
				{
					MessageBox	msg = new MessageBox(this , "Fehler" , "Bitte zuerst geschtzte Schlssellnge eingeben !");
				}
				else
				{
					String s = vigenere.GetKey(ftext.getText() , keylen);
					keytext.setText(s);
				}
			}
			catch (NumberFormatException error)
			{
				MessageBox	msg = new MessageBox(this , "Fehler" , "Bitte eine gltige Schlssellnge eingeben !");
			}
		}
				
		if (cmd == "Decode")
		{
			if ((ftext.getText().length() <= 0) || (keytext.getText().length() <= 0))
			{
				MessageBox	msg = new MessageBox(this , "Fehler" , "Bitte codierten Text und Schlssel eingeben !");
			}
			else
			{
				String s = vigenere.Decode(ftext.getText() , keytext.getText());
				ftext.setText(s);
			}
		}
	}//public void actionPerformed(ActionEvent e)


	//##########################################################################
	public static void main(String[] args)
	{
		aufgabe_4_2	frame = new aufgabe_4_2();
	}
};